diff --git a/src/usr/local/www/vpn_openvpn_client.php b/src/usr/local/www/vpn_openvpn_client.php
index 17a7aaf9dc..1ecd80d626 100644
--- a/src/usr/local/www/vpn_openvpn_client.php
+++ b/src/usr/local/www/vpn_openvpn_client.php
@@ -36,6 +36,9 @@ require_once("pkg-utils.inc");
 
 global $openvpn_topologies, $openvpn_tls_modes;
 global $openvpn_sharedkey_warning;
+global $openvpn_prots;
+
+$openvpn_all_data_ciphers = openvpn_get_cipherlist();
 
 config_init_path('openvpn/openvpn-client');
 
@@ -236,6 +239,7 @@ if ($_POST['save']) {
 	    !array_key_exists($pconfig['dev_mode'], $openvpn_dev_mode)) {
 		$input_errors[] = gettext("The selected Device Mode is not valid.");
 	}
+
 	if (!empty($pconfig['protocol']) &&
 	    !array_key_exists($pconfig['protocol'], $openvpn_prots)) {
 		$input_errors[] = gettext("The selected Protocol is not valid.");
@@ -246,7 +250,7 @@ if ($_POST['save']) {
 		$input_errors[] = gettext("The selected Interface is not valid.");
 	}
 
-	$cipher_validation_list = array_keys(openvpn_get_cipherlist());
+	$cipher_validation_list = array_keys($openvpn_all_data_ciphers);
 	if (!in_array($pconfig['data_ciphers_fallback'], $cipher_validation_list)) {
 		$input_errors[] = gettext("The selected Fallback Data Encryption Algorithm is not valid.");
 	}
@@ -427,8 +431,10 @@ if ($_POST['save']) {
 		}
 	}
 
-	if (($pconfig['mode'] == "p2p_shared_key") && strstr($pconfig['data_ciphers_fallback'], "GCM")) {
-		$input_errors[] = gettext("GCM Encryption Algorithms cannot be used with Shared Key mode.");
+	if (($pconfig['mode'] == "p2p_shared_key") &&
+	    (strstr($pconfig['data_ciphers_fallback'], "GCM") ||
+	    strstr($pconfig['data_ciphers_fallback'], "CHACHA"))) {
+		$input_errors[] = gettext("AEAD Encryption Algorithms (GCM, CHACHA) cannot be used with Shared Key mode.");
 	}
 
 	/* If we are not in shared key mode, then we need the CA/Cert. */
@@ -511,7 +517,7 @@ if ($_POST['save']) {
 		$client = array();
 
 		if ($this_client_config &&
-		    $pconfig['dev_mode'] <> $this_client_config['dev_mode']) {
+		    ($pconfig['dev_mode'] != $this_client_config['dev_mode'])) {
 			/*
 			 * delete old interface so a new TUN or TAP interface
 			 * can be created.
@@ -573,7 +579,6 @@ if ($_POST['save']) {
 		} else {
 			$client['shared_key'] = base64_encode($pconfig['shared_key']);
 		}
-		$client['data_ciphers_fallback'] = $pconfig['data_ciphers_fallback'];
 		$client['digest'] = $pconfig['digest'];
 
 		foreach (array('', 'v6') as $ntype) {
@@ -599,6 +604,7 @@ if ($_POST['save']) {
 		if (!empty($pconfig['data_ciphers'])) {
 			$client['data_ciphers'] = implode(",", $pconfig['data_ciphers']);
 		}
+		$client['data_ciphers_fallback'] = $pconfig['data_ciphers_fallback'];
 
 		$client['ping_method'] = $pconfig['ping_method'];
 		$client['keepalive_interval'] = $pconfig['keepalive_interval'];
@@ -928,12 +934,13 @@ if ($act=="new" || $act=="edit"):
 		$data_ciphers_list[$cipher] = $cipher;
 	}
 	$group = new Form_Group('Data Encryption Algorithms');
+	$group->addClass("datacipherlist");
 
 	$group->add(new Form_Select(
 		'availciphers',
 		null,
 		array(),
-		openvpn_get_cipherlist(),
+		$openvpn_all_data_ciphers,
 		true
 	))->setAttribute('size', '10')
 	  ->setHelp('Available Data Encryption Algorithms%1$sClick to add or remove an algorithm from the list', '<br />');
@@ -962,7 +969,7 @@ if ($act=="new" || $act=="edit"):
 		'data_ciphers_fallback',
 		'Fallback Data Encryption Algorithm',
 		$pconfig['data_ciphers_fallback'],
-		openvpn_get_cipherlist()
+		$openvpn_all_data_ciphers
 		))->setHelp('The Fallback Data Encryption Algorithm used for data channel packets when communicating with ' .
 				'clients that do not support data encryption algorithm negotiation (e.g. Shared Key). ' .
 				'This algorithm is automatically included in the Data Encryption Algorithms list.');
@@ -1541,6 +1548,7 @@ events.push(function() {
 
 	function updateCipher(mem) {
 		var found = false;
+		var ciphers_all = <?= json_encode($openvpn_all_data_ciphers) ?>;
 
 		// If the cipher exists, remove it
 		$('[id="data_ciphers[]"] option').each(function() {
@@ -1552,7 +1560,7 @@ events.push(function() {
 
 		// If not, add it
 		if (!found) {
-			$('[id="data_ciphers[]"]').append(new Option(mem , mem));
+			$('[id="data_ciphers[]"]').append(new Option(ciphers_all[mem], mem));
 		}
 	}
 
diff --git a/src/usr/local/www/vpn_openvpn_server.php b/src/usr/local/www/vpn_openvpn_server.php
index cf38b41d95..cdb5913a96 100644
--- a/src/usr/local/www/vpn_openvpn_server.php
+++ b/src/usr/local/www/vpn_openvpn_server.php
@@ -36,6 +36,9 @@ require_once("pkg-utils.inc");
 
 global $openvpn_topologies, $openvpn_tls_modes, $openvpn_exit_notify_server;
 global $openvpn_sharedkey_warning;
+global $openvpn_prots;
+
+$openvpn_all_data_ciphers = openvpn_get_cipherlist();
 
 config_init_path('openvpn/openvpn-server');
 
@@ -335,7 +338,7 @@ if ($_POST['save']) {
 		$input_errors[] = gettext("The selected ECDH Curve is not valid.");
 	}
 
-	$cipher_validation_list = array_keys(openvpn_get_cipherlist());
+	$cipher_validation_list = array_keys($openvpn_all_data_ciphers);
 	if (!in_array($pconfig['data_ciphers_fallback'], $cipher_validation_list)) {
 		$input_errors[] = gettext("The selected Fallback Data Encryption Algorithm is not valid.");
 	}
@@ -595,8 +598,10 @@ if ($_POST['save']) {
 		$reqdfieldsn = array(gettext('Shared key'));
 	}
 
-	if (($pconfig['mode'] == "p2p_shared_key") && strstr($pconfig['data_ciphers_fallback'], "GCM")) {
-		$input_errors[] = gettext("GCM Encryption Algorithms cannot be used with Shared Key mode.");
+	if (($pconfig['mode'] == "p2p_shared_key") &&
+	    (strstr($pconfig['data_ciphers_fallback'], "GCM") ||
+	    strstr($pconfig['data_ciphers_fallback'], "CHACHA"))) {
+		$input_errors[] = gettext("AEAD Encryption Algorithms (GCM, CHACHA) cannot be used with Shared Key mode.");
 	}
 
 	if ($pconfig['dev_mode'] == "tap") {
@@ -686,7 +691,8 @@ if ($_POST['save']) {
 
 		$server = array();
 
-		if ($this_server_config && $pconfig['dev_mode'] <> $this_server_config['dev_mode']) {
+		if ($this_server_config &&
+		    ($pconfig['dev_mode'] != $this_server_config['dev_mode'])) {
 			/*
 			 * delete old interface so a new TUN or TAP interface
 			 * can be created.
@@ -743,7 +749,6 @@ if ($_POST['save']) {
 			$server['shared_key'] = base64_encode($pconfig['shared_key']);
 		}
 
-		$server['data_ciphers_fallback'] = $pconfig['data_ciphers_fallback'];
 		$server['digest'] = $pconfig['digest'];
 
 		foreach (array('', 'v6') as $ntype) {
@@ -831,6 +836,7 @@ if ($_POST['save']) {
 		if (!empty($pconfig['data_ciphers'])) {
 			$server['data_ciphers'] = implode(",", $pconfig['data_ciphers']);
 		}
+		$server['data_ciphers_fallback'] = $pconfig['data_ciphers_fallback'];
 
 		$server['ping_method'] = $pconfig['ping_method'];
 		$server['keepalive_interval'] = $pconfig['keepalive_interval'];
@@ -1174,12 +1180,13 @@ if ($act=="new" || $act=="edit"):
 	))->setHelp('Paste the shared key here');
 
 	$group = new Form_Group('Data Encryption Algorithms');
+	$group->addClass("datacipherlist");
 
 	$group->add(new Form_Select(
 		'availciphers',
 		null,
 		array(),
-		openvpn_get_cipherlist(),
+		$openvpn_all_data_ciphers,
 		true
 	))->setAttribute('size', '10')
 	  ->setHelp('Available Data Encryption Algorithms%1$sClick to add or remove an algorithm from the list', '<br />');
@@ -1208,7 +1215,7 @@ if ($act=="new" || $act=="edit"):
 		'data_ciphers_fallback',
 		'Fallback Data Encryption Algorithm',
 		$pconfig['data_ciphers_fallback'],
-		openvpn_get_cipherlist()
+		$openvpn_all_data_ciphers
 		))->setHelp('The Fallback Data Encryption Algorithm used for data channel packets when communicating with ' .
 				'clients that do not support data encryption algorithm negotiation (e.g. Shared Key). ' .
 				'This algorithm is automatically included in the Data Encryption Algorithms list.');
@@ -2400,6 +2407,7 @@ events.push(function() {
 
 	function updateCipher(mem) {
 		var found = false;
+		var ciphers_all = <?= json_encode($openvpn_all_data_ciphers) ?>;
 
 		// If the cipher exists, remove it
 		$('[id="data_ciphers[]"] option').each(function() {
@@ -2411,7 +2419,7 @@ events.push(function() {
 
 		// If not, add it
 		if (!found) {
-			$('[id="data_ciphers[]"]').append(new Option(mem , mem));
+			$('[id="data_ciphers[]"]').append(new Option(ciphers_all[mem], mem));
 		}
 	}
 
diff --git a/src/usr/local/www/widgets/widgets/interfaces.widget.php b/src/usr/local/www/widgets/widgets/interfaces.widget.php
index 0f629eee2c..d992ac37de 100644
--- a/src/usr/local/www/widgets/widgets/interfaces.widget.php
+++ b/src/usr/local/www/widgets/widgets/interfaces.widget.php
@@ -91,7 +91,8 @@ foreach ($ifdescrs as $ifdescr => $ifname):
 	$known_status = true;
 
 	// Choose an icon by interface status
-	if ($ifinfo['status'] == "up" || $ifinfo['status'] == "associated") {
+	if ($ifinfo['status'] == "up" ||
+	    $ifinfo['status'] == "associated") {
 		$icon = 'fa-solid fa-arrow-up text-success';
 	} elseif ($ifinfo['status'] == "no carrier") {
 		$icon = 'fa-solid fa-times-circle text-danger';
diff --git a/src/usr/local/www/widgets/widgets/system_information.widget.php b/src/usr/local/www/widgets/widgets/system_information.widget.php
index dd33d4dcd4..e72dd9c502 100644
--- a/src/usr/local/www/widgets/widgets/system_information.widget.php
+++ b/src/usr/local/www/widgets/widgets/system_information.widget.php
@@ -56,7 +56,7 @@ $sysinfo_items = array(
 	);
 
 // Declared here so that JavaScript can access it
-$updtext = sprintf(gettext("Obtaining update status %s"), "<i class='fa-solid fa-cog fa-spin'></i>");
+$updtext = sprintf(gettext("Obtaining update status %s"), "<i class='fa-solid fa-rotate fa-spin'></i>");
 $state_tt = gettext("Adaptive state handling is enabled, state timeouts are reduced by ");
 
 if ($_REQUEST['getupdatestatus']) {
@@ -126,7 +126,7 @@ if ($_REQUEST['getupdatestatus']) {
 		<?printf("%s %s", gettext("Version information updated at"),
 		    date("D M j G:i:s T Y", filemtime($cache_file)));?>
 		    &nbsp;
-		    <a id="updver" href="#" class="fa-solid fa-arrows-rotate"></a>
+		    <a id="updver" href="#" class="fa-solid fa-rotate"></a>
 	</div>
 <?php
 	endif;
@@ -300,7 +300,13 @@ $temp_use_f = (isset($user_settings['widgets']['thermal_sensors-0']) && !empty($
 			$cpucount = get_cpu_count();
 			if ($cpucount > 1): ?>
 				<div id="cpucount">
-					<?= htmlspecialchars($cpucount) ?> <?=gettext('CPUs')?>: <?= htmlspecialchars(get_cpu_count(true)); ?>
+					<?= htmlspecialchars($cpucount) ?> <?=gettext('CPUs')?>
+<?php
+				$cpudetail = get_cpu_count(true);
+				if ($cpudetail != $cpucount): ?>
+					: <?= htmlspecialchars($cpudetail); ?>
+<?php
+				endif; ?>
 				</div>
 		<?php endif; ?>
 				<div id="cpucrypto">
diff --git a/src/usr/local/www/wizard.php b/src/usr/local/www/wizard.php
index adcffa9320..8528ebcff6 100644
--- a/src/usr/local/www/wizard.php
+++ b/src/usr/local/www/wizard.php
@@ -871,6 +871,30 @@ if ($pkg['step'][$stepid]['fields']['field'] != "") {
 				  ->setAttribute('rows', $field['rows'])
 				  ->setOnchange(($field['validate']) ? "FieldValidate(this.value, \"" . $field['validate'] . "\", \"" . $field['message'] . "\")":"");
 
+				break;
+			case "textarea_source":
+				if ($field['displayname']) {
+					$etitle = $field['displayname'];
+				} else if (!$field['dontdisplayname']) {
+					$etitle =  fixup_string($field['name']);
+				}
+
+				$source = $field['source'];
+				try{
+					@eval("\$value = &$source;");
+				} catch (\Throwable | \Error | \Exception $e) {
+					log_error($e);
+				}
+				$input = $section->addInput(new Form_Textarea(
+					$name,
+					$etitle,
+					$value
+				))->setHelp($field['description'])
+				  ->setAttribute('rows', $field['rows'])
+				  ->setOnchange(($field['validate']) ? "FieldValidate(this.value, \"" . $field['validate'] . "\", \"" . $field['message'] . "\")":"");
+				if ($field['readonly']) {
+					$input->setReadonly();
+				}
 				break;
 			case "submit":
 				$form->addGlobal(new Form_Button(
